#!/bin/csh
# this file tries to copy the right file into cfg.mak
# and build the dummy mak.cfg which is not on the tape
    if ( -f mak.cfg ) rm -f mak.cfg
    if ( -f cfg.chk ) rm -f cfg.chk
    uname -s 
    if ( $status == 0 ) then
      set UNAME=`uname -s`
      switch ($UNAME)
         case HP-UX : 
                      set ARCH='hp-ux'
                      cc -Aa >& cfg.chk
                      grep  -q  option cfg.chk
                      if ( $status != 0 ) set KK=ansi
                      breaksw
         case SunOS : 
                      set ARCH='sunOs'
                      cc -Aa >& cfg.chk
                      grep  -s  Xa cfg.chk
                      if ( $status == 0 ) set KK=ansi
                      breaksw
         case AIX : 
                      set ARCH='aix'
                      set KK=ansi
                      breaksw
         case Linux : 
                      set ARCH='linux'
                      set KK=ansi
                      breaksw
         default :    
                      echo ' default'
                      set ARCH='unknown'
                      echo $ARCH
                      breaksw
         endsw             

#not known
    if  ( ! $?ARCH ) then
       set ARCH='unknown'
       endif

echo the system has been found as $ARCH

    if  ( $?KK ) then
       echo the compiler accepts $KK option
       set KERNEL=$ARCH.$KK
       else
       echo ansi option has not been recognised
       set KERNEL=$ARCH
       endif
 
# now copies the right file into cfg.mak and info in mak.cfg
    if ( -f $KERNEL.mak ) then
       cp  $KERNEL.mak cfg.mak
       date >! mak.cfg
       echo "KERNEL $KERNEL" >> mak.cfg 
       echo "make will use $KERNEL.mak"  
    else
       cp unknown.mak cfg.mak 
       date >! mak.cfg
       echo "KERNEL unknown" >> mak.cfg 
       date >! mak.cfg
       echo "make will use unknown.mak, $KERNEL.mak not found"
       set KERNEL=unknown  
    endif
    echo "make has been configured for $KERNEL"
    echo "it will exit now, just retype make"
    set  PID=`ps | grep make | awk '{print $1;}'`
    kill -9 $PID
    exit 1
