/*  XF.C fourrier simplifie pour xnd    definitions generales */

/* reconnait le compilateur Borland comme specifique MSDOS  */
#ifdef __TURBOC__
/* verifie dans ce cas le modele de memoire utilisee */

#ifndef __LARGE__
/* #error modele de memoire incorrect : LARGE necessaire sous MSDos */
#endif

#define  MS_DOS
#define  SECU_ALLOC   16       /* 16 for PC */
#define  MAX_ALLOC 65520L      /* 64kO-16 for PC */

#else
  	 /* ANSI defined prototypes not known in K.R. (SUN3.5) */
#define  NO_PROTO
#define  SECU_ALLOC   0       /* 16 for PC */
#define  MAX_ALLOC 500000L    /* 500 k dans le meme tableau, par exemple */
#endif
 


/* #define T_HKL 1 */


#ifdef   NO_PROTO
#define  PROTO(a)  ()
#define  P_(a)

#else
#define  PROTO(a)  a
#define  P_(a)     a

#include <stdlib.h>
#include <stdarg.h>
#endif

#include <stdio.h>
#include <values.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

#define  VERS       "XF 0.8"
#ifndef  __DATE__
#define	 __DATE__   "10/9/96"
#endif

#define  NAME_LG      200	/* string length */

#define  PROG_PATH ""
#define  EPSILON  1.0E-12	/* in some tests */

#ifndef LN_MAXFLOAT
#define  LN_MAXFLOAT  89.6	/* ln(MAXFLOAT) */
#endif

#define  RAD            ( M_PI / 180.0 )

typedef struct
{     char    nom[NAME_LG];
      char    systeme;
      char    holoedre;
      char    bravais;
      char    centro;
      char    nops;
      float   coef[12];    /* (xx, xy, xz, tx, yx......zz, tz ) * nops */
      }       SYMGRP;

typedef struct
{      float    matr[6];
       float    vect[3];
       }        SYMOP;

typedef struct
{      int h,k,l;
       float t;
       float fo_abs;
       float fo_phi;
       }       BRAGG;



 char  titre[NAME_LG];
 char  *str_time;
				     /*  file system */
 FILE  *list_fich;
 FILE  *coord_fich;
 FILE  *hkl_fich;
 FILE  *rho_fich;

 SYMGRP *symgrp;
 BRAGG  *hkl,*l_hkl;
				   /* actual parameters */
int    lambda,phase,mode;
int    n_hkl,m_hkl;
int    n_max,d_max;
int    n_min,d_min;
float  x,y,z;
float  xo,yo,zo;
float  xd,yd,zd;
float  xe,ye,ze;
float  dxx,dxy,dxz,dyx,dyy,dyz,dzx,dzy,dzz;
int    nx,ny,nz;
float  rho,volume;
int    imag;
int map =0;

float  *maxrho;
float  *minrho;

BRAGG   act;
#define H act.h
#define K act.k
#define L act.l
#define F act.fo_abs
#define P act.fo_phi
#define T act.t

#include <string.h>
#include <time.h>
/* ------------------------------------------------------------------ */

void termine PROTO((int cas, char * msg));
void image_file PROTO((float * t_rho, float minrho, float maxrho, int map, int ny, int nz));

/* ------------------------------------------------------------------ */
void strup (P_(char *) string)
#ifdef NO_PROTO
char * string;
#endif
{	char *c;
	c = string;
	while (*c !=0)
	{	if (islower(*c)) *c = toupper(*c);
		c++;

	}	}

/* ------------------------------------------------------------------ */
#define  E_ALLOC "Allocation Memoire %u * %u : %s\n"

#ifndef NO_PROTO
void tst_abort (int test, char *format, ... )
{   char msg[80];
    va_list argptr;
    if (test)
    {    va_start (argptr, format);
	 vsprintf (msg,format, argptr);
	 va_end (argptr);
	 termine(2, msg);
    }   }
#else
#include <varargs.h>
void tst_abort (va_alist)
va_dcl
{   va_list args;
    int test;
    char *format;
    char msg[80];
    va_start (args);
    test = va_arg(args, int);
    if (test)
    {    format = va_arg(args, char *);
	 vsprintf (msg,format, args);
	 va_end (args);
	 termine(2, msg);
    }   }
#endif


void *tst_alloc (P_(int) nb, P_(int) size, P_(char *) name)
#ifdef NO_PROTO
int nb;
int size;
char *name;
#endif
{   void  *ptr;
    char msg[80];
    if (size * (long) nb > MAX_ALLOC)
    {    sprintf (msg," Alloc %d * %d %s > %ld",nb,size,name,MAX_ALLOC);
	 termine (1,msg);
	 }
    if (nb && size) ptr = (void *) calloc (nb,size); else ptr = NULL;
    if (ptr==NULL && nb!=0)
	{    sprintf (msg,E_ALLOC,nb,size,name);
	while (ptr == NULL)
	{	nb = (nb * 3) / 4;
		ptr = (void *) calloc (nb,size);
		if (ptr != NULL)
		{   	 fprintf(list_fich," Memoire restante disponible pour %u elements de dimension %u\n",nb, size);	
			 termine (1, msg);
			}
		if (nb <= 2)
		{ 	fprintf (list_fich," Aucune memoire disponible\n");
			 termine (1, msg);
			}
	}	 }
    return ptr;
    }


/* ------------------------------------------------------------------ */

void fprint_xyz_pos (P_(FILE *) file, P_(float *) l_coef, P_(char) end_char)
#ifdef NO_PROTO
FILE *file;
float *l_coef;
char end_char;
#endif
{   int   i,j;
	float val;
	float *coef;
	int   num,deno,first;

	fprintf(file,"  ");
	for (j=0,coef=l_coef; j<3; j++,coef++)
	{   	first =1;
		for (i=0; i<4; i++)
		{   val = coef[3*i];
			if (fabs(val)>EPSILON)
			{   if (val>0) num = floor (val * 24 + EPSILON);
				else num = ceil (val*24 - EPSILON);
				deno = 24;
				while ((num%2==0) && (deno%2==0)) { num/=2; deno/=2; }
				while ((num%3==0) && (deno%3==0)) { num/=3; deno/=3; }
				if (i==3) fprintf (file,"%+d",num);
				else if (num==1) fprintf (file,"%s%c",first?"":"+",'X'+i);
				else if (num==-1) fprintf (file,"-%c",'X'+i);
				else fprintf (file,"%d%c",num,'X'+i);
				if (deno!=1) fprintf (file,"/%d",deno);
				first = 0;
				}
			 }
		if (j!=2) fprintf (file,", ");
		}
	fprintf (file,"%c",end_char);
	}

/* ------------------------------------------------------------------ */

void imprime_sym(P_(SYMGRP *) symgrp, P_(int) cas)
#ifdef NO_PROTO
SYMGRP *symgrp;
int cas;
#endif
{   int i;
    float *l_coef;

	if (cas) fprintf(list_fich," groupe de symetrie '%s'\n", symgrp->nom);
	fprintf(list_fich, " systeme %c holoedrie %d, %d %s, %d operations \n",
		symgrp->systeme,symgrp->holoedre, symgrp->centro,
		symgrp->centro==1?"(-x,-y,-z) * ":"NonCentro",symgrp->nops);
	for (i=0,l_coef=symgrp->coef; i<symgrp->nops; i++,l_coef+=12)
    {   fprintf (list_fich," #%2d ",i);
		fprint_xyz_pos (list_fich, l_coef, '\n');
		 }
    fprintf(list_fich,"\n");
    }

/* ------------------------------------------------------------------ */

void analyse_xyz_pos(P_(char *) ligne, P_(float *) l_coef, P_(SYMGRP *) l_sym)
#ifdef NO_PROTO
char *ligne;
float *l_coef;
SYMGRP *l_sym;
#endif
{   float  num,deno;
    int    div,dig,sig;
	int    j;
    char   *ligne_p,car;

	if (strlen(ligne)>=NAME_LG) ligne[NAME_LG-1]=0;
	strup (ligne);
	ligne_p=ligne;
	num = deno = 0;
	j = dig = div = 0;
	sig = 1;
	while ((car= *ligne_p)!=0)
	{   ligne_p++;
		if (isdigit(car))
		{   dig++;
			if (div==0) num = num*10+car-'0';
			else deno = deno*10+car-'0';
			}
	     else if (car=='/')
	     {   if (num==0) num = 1;
			 div=1;
			 }
	     else switch (car)
		 {   case 'X' :
			 case 'Y' :
			 case 'Z' : if (div!=0) num /= deno;
						if (num==0) num = 1;
						l_coef [j+3*(car-'X')] = sig*num;
						sig = 1; num=deno=0; div=0;
						break;
			 case ',' :
			 case '-' :
			 case '+' : if (div!=0)  num /= deno;
						if (num!=0) l_coef [j+9] = sig*num;
						num=deno=0; div=0;
						sig = car=='-'?-1:1;
						if (car==',') j++;
						break;
			 default  : if (car!=' ')
						{  if (l_sym!=NULL) fprintf (list_fich," Groupe '%s'",l_sym->nom);
						   fprintf(list_fich,"  Erreur interpretation de '%c' dans '%s'\n",
							  car,ligne);
						   }
			 }
		}
	if (div!=0)  num /= deno;
	if (num!=0) l_coef [j+9] = sig*num;
	}

/* ------------------------------------------------------------------ */

SYMGRP *lecture_sym (P_(FILE *) file)
#ifdef NO_PROTO
FILE *file;
#endif
{   char  ligne[160], copie[60],name[60];
    char *pos;
    int   i,j;
    char  systeme,bravais;
    int   holo,centro,nops;
    float  *l_coef;
    SYMGRP *l_sym;

    fscanf(file," %s", name);
    fgets (ligne, 120, file);  /* the end of the line with comments... */
    if (feof(file)) return NULL;
    pos=ligne;
    while ( *pos == ' ' || *pos == '\r' ) pos++;
    fscanf(file," %[CQHTROMNLA*]", copie);
    if (strlen(ligne)>=NAME_LG) ligne[NAME_LG-1]=0;
    systeme = copie[0];
    bravais = ligne[0];
    fscanf(file," %d%d%d",&holo,&centro,&nops);
    strup(ligne);
    l_sym = (SYMGRP *)tst_alloc(1,sizeof(SYMGRP)+12*(nops-1)*sizeof(float), "symgrp");
    strcpy(l_sym->nom,ligne);
    l_sym->systeme=systeme;
    l_sym->holoedre=holo;
    l_sym->bravais=bravais;
    l_sym->centro=centro;
    l_sym->nops=nops;
    for (j=0,l_coef=l_sym->coef;j<nops*12;j++,l_coef++) *l_coef = 0;
    for (i=0,l_coef=l_sym->coef;i<nops;i++,l_coef+=12)
	{   fscanf(file," %[^;\n]%*[;\n]",ligne);
		analyse_xyz_pos (ligne, l_coef, l_sym);
		}
    return(l_sym);
    }

/* ------------------------------------------------------------------ */
int lecture_hkl (P_(int) pos)
#ifdef NO_PROTO
int pos;
#endif
{   int   p,l;
    float io,ic,fa,fb;
    float mu,orien,cor,dphi;
    BRAGG *deb,*bragg;
    int    hh,kk,ll;
    int     ii,i,j,n;
    float    *l_coef;
    char ligne[200];
    do
	{   i = fscanf (hkl_fich,
" %*d %*[(]%d%*[)]%d%d%d %*[(]%d%*[)]%f %*c%f%f %*[(]%f%f%*[)]%*f%*f%*f%*f%f%f%f %*[^\n]",
	   &p,&H,&K,&L,&l,&T,&io,&ic,&fa,&fb,&mu,&orien,&cor);
#ifdef T_HKL
	  fprintf  (list_fich," (%d) %d %d %d (%d) %.3f Io %.1f %.1f  F %.2f %.2f\n",p,H,K,L,l,T,io,ic,fa,fb);
#endif
	if( i == 0 )
	{       fgets(ligne,199,hkl_fich);
	        continue;
	        }
	        if (i != 13 && !feof(hkl_fich) )
	{ 	fprintf (list_fich,"Erreur lecture hkl %d (%d,%d,%d) %.3f %.1f %d valeurs lues \n",pos,H,K,L,T,io,i);
		printf ("Erreur lecture hkl %d\n",pos);
		return (0);   }
	if (i == -1 || feof(hkl_fich) )
	{ 	return (0);   }
	        }
    while ((p!=phase || l!=lambda) && !feof(hkl_fich));
    if (p!=phase || l!=lambda) return (0);
	if (io<=0) io=0;

    P=0;
    if (mode == 2) F = io/=mu*orien*cor;
    else if (mode == 3) F = (io-ic)/(mu*orien*cor);
    else
    {   if (ic < 0.1) ic = 0.05;
        cor = sqrt(io / ic);
	F = sqrt (fa*fa+fb*fb);
	if (F > EPSILON) P = atan2 (fb, fa);
	if (mode == 1)   F *= cor - 1; 
        else if ( mode == 0 ) F *= cor;
#ifdef T_HKL
	  fprintf  (list_fich," F %f cor %f\n", F, cor);
#endif
	 }
    *l_hkl = act;
    deb = l_hkl;
    l_hkl++;
    n=1;
    for (i=0,l_coef=symgrp->coef;i<symgrp->nops;i++,l_coef+=12)
    {   hh = l_coef[0] * H + l_coef[1] * K + l_coef[2] * L;
	kk = l_coef[3] * H + l_coef[4] * K + l_coef[5] * L;
	ll = l_coef[6] * H + l_coef[7] * K + l_coef[8] * L;
	dphi = hh * l_coef[9] + kk * l_coef[10] + ll * l_coef[11];
	ii=0;
	for (j=0,bragg=deb;j<n;j++,bragg++)
	   if (hh==bragg->h && kk==bragg->k && ll==bragg->l) ii++;
	if (ii==0)
	{    l_hkl->h = hh;
	     l_hkl->k = kk;
	     l_hkl->l = ll;
	     l_hkl->t = act.t;
	     l_hkl->fo_abs = act.fo_abs;
	     l_hkl->fo_phi = act.fo_phi - 2 * M_PI * dphi;
#ifdef T_HKL
	  fprintf  (list_fich," (%d) ajoute %d %d %d  dphi %f fo %f phi %f\n",n,hh,kk,ll,dphi,l_hkl->fo_abs,l_hkl->fo_phi);
#endif
	     l_hkl++;
	     n++;
	     }
	}
	return n;
  	}

/* ------------------------------------------------------------------ */

void read_init (P_(int) argn, P_(char **) argv)
#ifdef NO_PROTO
int argn;
char **argv;
#endif
{    char   file_name[NAME_LG];
     int i, nl_hkl;

	if (argn < 2)
	{   printf ("Usage : '%s data_file'   consulter '%sxf_doc.d'\n", 
		argv[0],PROG_PATH);
		exit (3);
		}

       coord_fich = fopen ( argv[1], "rt");
       printf ("\n %s : %s (%s)\n",argv[0],VERS,__DATE__);
	if (coord_fich==NULL)
	{	printf(" Impossible d'ouvrir '%s'\n",argv[1]);
		exit (3);
		}
    fscanf (coord_fich," %[^\n]%*[\n] %[^\n]",titre,file_name);

    list_fich = freopen ( file_name, "w",stderr);
    if (list_fich==NULL)
    {    printf (" Impossible d'ouvrir le listing '%s'\n",file_name);
	   exit (3);
	   }
    fprintf (list_fich," %s : %s (%s) :  %s\n\n fichiers '%s' --> '%s ':  %s",
	    argv[0],VERS,__DATE__,titre,argv[1],file_name,str_time);

    n_max = 20; n_min = 10;
    i = fscanf  (coord_fich,"%d%f%d%d%d%d%d",
	      &mode,&volume,&nl_hkl,&phase,&lambda,&n_max,&n_min);
    fprintf (list_fich," mode %d ( 0 fo, 1 df, 2 f2, 3 df2, 4 fc) volume %.1f \n\
 %d HKL a lire : Phase # %d lambda # %d impression des %d max et %d min\n",mode,volume,nl_hkl,phase,lambda,n_max,n_min);
	tst_abort ((i<5),"  ERREUR lecture param init (1-5)");
  if (volume <= 0) volume = 1;

    fscanf (coord_fich," %[^\n]%*[n]",file_name);
    hkl_fich = fopen ( file_name, "rt");
    if (hkl_fich==NULL)
    {    printf (" impossible d'ouvrir hkl :'%s'\n",file_name);
	   exit (3);
	   }
    fprintf (list_fich," fichier HKL : %s\n",file_name);
    fscanf (coord_fich," %[^\n]%*[n]",file_name);
    rho_fich = fopen ( file_name, "wt");
    if (rho_fich==NULL)
    {    printf (" impossible d'ouvrir rho : '%s'\n",file_name);
	   exit (3);
	   }
    fprintf (list_fich," fichier densite : %s\n\n",file_name);
   fflush (list_fich);

   symgrp = lecture_sym (coord_fich);
   imprime_sym (symgrp, 1);
   fflush (list_fich);

   if (symgrp->centro==0 && (mode<=1 || mode ==4) ) imag = 1; else imag =0;
   m_hkl =  (nl_hkl+1)*symgrp->nops;
   n_hkl=0;
   fprintf(list_fich," %d HKL reserves\n",m_hkl);
   l_hkl =  hkl = (BRAGG *) tst_alloc (m_hkl,sizeof(BRAGG),"bragg");
   fscanf (hkl_fich," %[^\n]%*[\n] %*[^\n]%*[\n]",file_name);
   fprintf(list_fich," HKL : %s\n",file_name);
   for (i=0;i<nl_hkl && !feof(hkl_fich);i++) n_hkl += lecture_hkl (i);
   fprintf(list_fich," %d HKL utilises \n",n_hkl);
   fflush (list_fich);
   d_max = 4 * n_max;
   d_min = 4 * n_min;
   maxrho = (float *) tst_alloc(4+d_max,sizeof(float),"maxrho");
   minrho = (float *) tst_alloc(4+d_min,sizeof(float),"maxrho");
   fflush(list_fich);
   }


long  secs_start;

float  calcul PROTO((void));
void   minmaxrho PROTO((void));

void main (P_(int) argn, P_(char **) argv)
#ifdef NO_PROTO
int argn;
char **argv;
#endif
{   int i,j,n,ix,iy,iz;
    float *t_rho;
    int pix;

    time (&secs_start);
    str_time= ctime(&secs_start);

    read_init (argn, argv);
    
     while (! feof(coord_fich))
     {
    i = fscanf  (coord_fich,"%f%f%f %d%f%f%f %d%f%f%f %d%f%f%f",
      &xo,&yo,&zo, &nx,&dxx,&dxy,&dxz, &ny,&dyx,&dyy,&dyz, &nz,&dzx,&dzy,&dzz);
     if (i < 11) break; 
    fprintf (list_fich,"\n# Xo %.4f Yo %.4f Zo %.4f\n# NX %d  DX %.4f %.4f %.4f\n\
# NY %d  DY %.4f %.4f %.4f\n# NZ %d  DZ %.4f %.4f %.4f\n",
      xo,yo,zo,nx,dxx,dxy,dxz,ny,dyx,dyy,dyz,nz,dzx,dzy,dzz);
     
 
    fprintf (rho_fich,"\n# Xo %.3f Yo %.3f Zo %.3f\n# NX %d  DX %.3f %.3f %.3f\n#\
 NY %d  DY %.3f %.3f %.3f\n# NZ %d  DZ %.3f %.3f %.3f\n",
      xo,yo,zo,nx,dxx,dxy,dxz,ny,dyx,dyy,dyz,nz,dzx,dzy,dzz);
      
    t_rho = (float *) malloc((ny+1)*(nz+1)*sizeof(float));
    xd=0; yd=0; zd=0;
    for (ix=0; ix< nx; ix++, xd+=dxx, yd +=dxy, zd+=dxz)
    {   fprintf (rho_fich,"#MAP %d %d %d level %d\n",++map, ny,nz, ix);
        fprintf (list_fich,"\n#MAP %d %d %d level %d\n",map, ny,nz,ix);
        printf ("\n#MAP %d %d %d level %d\n",map, ny,nz,ix);
        for (i=0;i<n_max;i++) maxrho[4*i] = -MAXFLOAT;
        for (i=1;i<=n_min;i++) minrho[4*i] = MAXFLOAT;
        xe=xd; ye=yd; ze=zd;
 	pix=0;
 	for (iy=0; iy< ny; iy++, xe+=dyx, ye +=dyy, ze+=dyz)
	{   x=xo+xe; y=yo+ye; z=zo+ze;
 	    for (iz=0; iz< nz; x+=dzx, y +=dzy, z+=dzz)
	    {    rho = calcul()/volume;
		 fprintf(rho_fich,"%.2f%s",rho,(++iz % 10)==0?"\n":"  ");
		 if (t_rho) t_rho[pix++]=rho;
		 minmaxrho();
		 } 
	     fprintf(rho_fich,"%s\n",iz%10 !=0 ?"\n":"");
             }
        printf("#MINMAX %lf %lf\n",minrho[4*n_min], maxrho[0]); 
        fprintf(rho_fich,"\n#MINMAX %lf %lf\n",minrho[4*n_min], maxrho[0]); 
        fprintf(rho_fich,"\n"); fflush(rho_fich);
        
        if (t_rho) image_file( t_rho, minrho[4*n_min],maxrho[0], map, ny, nz);
      fprintf(list_fich," les %d points maximum\n",n_max);
    n=0;
    for (i=0;i<n_max;i++)
    {	x = maxrho[1+4*i];
    	y = maxrho[2+4*i];
    	z = maxrho[3+4*i];
        fprintf(list_fich," %3d x=%7.4f y=%7.4f z=%7.4f %7.1f",i+1,x,y,z, 
          maxrho[4*i]);
        for (j=0; j<i; j++) 
			 if ((n=voisin(j, maxrho) )!= 0 ) fprintf(list_fich, " %2d",n);
        fprintf (list_fich, "\n");
	}
     	fprintf(list_fich," les %d points minimum\n",n_min);
     	n = 0;
	for (i=n_min;i>0;i--)
    {	x = minrho[1+4*i];
    	y = minrho[2+4*i];
    	z = minrho[3+4*i];
        fprintf(list_fich," %3d x=%7.4f y=%7.4f z=%7.4f %7.1f",
        n_min-i+1,x,y,z, minrho[4*i]);
        for (j=n_min; j>i; j--) 
          if ((n=voisin(j, minrho) )!= 0 ) fprintf(list_fich, " %2d",2+n_min-n);
        fprintf (list_fich, "\n");
	}
	fflush (list_fich);
	}
     if (t_rho) free(t_rho);
     }
    termine (0, "");
   }

void termine (P_(int) cas, P_(char *) msg)
#ifdef NO_PROTO
int cas;
char *msg;
#endif
{   long secs_now;
    time (&secs_now);
    str_time = ctime (&secs_now);
	fprintf (list_fich,"\n %s %s \n duree %lds STOP %d,  %s\n\n",cas==0?"":"ERROR",
	      msg,secs_now-secs_start,cas,str_time);
    printf ("\n %s %s \n duree %lds STOP %d, %s",cas==0?"":"ERROR",
	      msg,secs_now-secs_start,cas,str_time);
    fclose (list_fich);
    fclose (rho_fich);
    exit (cas);
    }

float calcul ()
{   int i;
    float rr = 0;
    float ri = 0;
    float phi;
    for (i=0, l_hkl = hkl; i<n_hkl; i++, l_hkl++)
    {   phi = 2*M_PI * (l_hkl->h * x + l_hkl->k * y + l_hkl->l * z);
	/* XND utilise la transfo avec signe + , donc -phi */
	rr += l_hkl->fo_abs * cos (l_hkl->fo_phi - phi);
	}
    return (2*rr);
    }

int fmaxrho (p, q)
float *p, *q;
{  if (*p > *q) return (-1);
   if (*p == *q) return (0);
   return (1);
   }

void minmaxrho ()
{   minrho[0]=maxrho[d_max] = rho;
	minrho[1]=maxrho[1+d_max] = x;
	minrho[2]=maxrho[2+d_max] = y;
	minrho[3]=maxrho[3+d_max] = z;
	qsort ( maxrho, (int) 1+n_max, (int) 4*sizeof(float), fmaxrho);
	qsort ( minrho, (int) 1+n_min, (int) 4*sizeof(float), fmaxrho);
    }

int  voisin ( j , table)
int j;
float *table;
{    float ecart;
     float emax;

     ecart = fabs( x - table[1+4*j]);
     ecart -= floor(ecart);
     emax  = fabs( dyx + dzx) + 0.0001;
     if ( ecart - emax > 0 ) return 0;
     ecart = fabs( y - table[2+4*j]);
     ecart -= floor(ecart);
     emax  = fabs( dyy + dzy) + 0.0001;
     if ( ecart - emax > 0 ) return 0;
     ecart = fabs( z - table[3+4*j]);
     ecart -= floor(ecart);
     emax  = fabs( dyz + dzz) + 0.0001;
     if ( ecart - emax > 0 ) return 0;

     return j+1 ;
     }

/*================================================*/
#ifdef MS_DOS
#define DWORD long int
#define WORD  int
#else
#define DWORD long int
#define WORD  short
#endif
#define COLORS 256
void swap PROTO(( void *l, int size));

void image_file(P_(float *) t_rho, P_(float) minrho, P_(float) maxrho, 
      P_(int) map, P_(int) ny, P_(int) nz)
#ifdef NO_PROTO
float * t_rho;
float minrho, maxrho;
int map, ny, nz;
#endif
{
	 FILE *image;
    char image_name[100];
    float scale, colscale;
	 int oy,oz,i,j,k;
    struct
    {   char h[2];  /*pour aligner sur hp */
        char  bm[2];
        DWORD size;
        DWORD dummy;
        DWORD shift;
        } header;
    struct 
    {  DWORD infosize;
       DWORD width;
       DWORD height;
       WORD  planes;
       WORD  bitcol;
       DWORD compress;
       DWORD imagsize;
       DWORD xratio;
       DWORD yratio;
       DWORD colors;
       DWORD colorimp;
		 } info;
struct
{  unsigned char blue, green, red, dummy;
   }  qrgb;
	 unsigned char val;
	 int kzero;
        
	 oy = ((ny+3)/4)*4;
	 oz = nz + 8;
	 sprintf(image_name,"%s_%d.bmp","xf",map);
    image = fopen(image_name,"wb");
    if (!image ) return;
    printf("%s\n", image_name);
    header.bm[0]='B'; header.bm[1]='M';
    header.size=oy*oz+sizeof(info)+sizeof(header)-2+COLORS*sizeof(qrgb);
    header.dummy=0;
    header.shift=sizeof(info)+COLORS*sizeof(qrgb)+sizeof(header)-2;
    swap(&header.size, sizeof(header.size));
    swap(&header.shift, sizeof(header.shift));
	 fwrite( &header.bm, 1, sizeof(header)-2, image);
    info.infosize=sizeof(info);
    info.width=ny;
    info.height=oz;
    info.planes=1;
    info.bitcol=8;
    info.compress=0;
	 info.imagsize=ny*oz;
    info.xratio=1;
    info.yratio=1;
	 info.colors=COLORS;
	 info.colorimp=0;
    swap(&info.infosize,   sizeof(info.infosize));
    swap(&info.width,  sizeof(info.width));
    swap(&info.height, sizeof(info.height));
    swap(&info.planes, sizeof(info.planes));
    swap(&info.bitcol, sizeof(info.bitcol));
    swap(&info.compress, sizeof(info.compress));
    swap(&info.imagsize, sizeof(info.imagsize));
    swap(&info.xratio, sizeof(info.xratio));
    swap(&info.yratio, sizeof(info.yratio));
    swap(&info.colors, sizeof(info.colors));
    swap(&info.colorimp, sizeof(info.colorimp));
    fwrite( &info, 1, sizeof(info), image);
    scale = (COLORS-3) / ( maxrho-minrho);
    kzero = -minrho*scale;
    qrgb.dummy=0;
    for (i=0;i<COLORS;i++)
    {    if ( i < kzero )
	 {   /* negatif en blue */
		qrgb.red = 0;
		k = kzero-i;
		if (k < 64 )
		{    qrgb.blue = 4*k;
		     qrgb.green=0;
		     }
		else if (k < 128 )
		{    qrgb.blue = 255;
		     qrgb.green=4*(k-64);
		     }
		else     
		{    qrgb.green = 255;
		     qrgb.blue=2*(255-k);
		     }
		}
	  else if ( i == kzero )
	  {	qrgb.red = qrgb.blue = qrgb.green = 0;
	        }
	  else if ( i < COLORS-2)
	  {     qrgb.blue=0;
		k = i-kzero;
		if (k < 64 )
		{    qrgb.red = 4*k;
		     qrgb.green=0;
		     }
		else if (k < 128 )
		{    qrgb.red = 255;
		     qrgb.green=4*(k-64);
		     }
		else     
		{    qrgb.green = 255;
		     qrgb.red=2*(255-k);
		     }
		}
	  else	
		qrgb.red=qrgb.blue=qrgb.green= 255;
/*printf("i %3d %3d %3d %2x %2x %2x\n", 
i, k, kzero, qrgb.blue, qrgb.red, qrgb.green);
*/   	  fwrite(&qrgb, 1, sizeof(qrgb), image);
	  }
 /* puis axe puis espace*/
     colscale= (float)COLORS/(float)ny;
     for (i=0; i< 4;i++)
     {    for (j=0;j<ny;j++)
	  {     val = j * colscale;
/*if (i==0)printf( " j %3d %2x %f\n", j, val, colscale);*/
		fwrite( &val, 1, sizeof(val), image);
		}
	  for (j=ny;j<oy;j++)
	  {     val=0;
	        fwrite( &val, 1, sizeof(val), image);
		}
	  }
   for (i=0; i< 4;i++)
   {    k=0;
        for (j=0;j<oy;j++)
	{    if ( j*COLORS>kzero*ny && i < 2 && k++==0 ) val = kzero; else val=255;
	     fwrite( &val,1, sizeof(val), image);
	     }
	  }
   /* la carte */
   for (i=0; i< nz;i++)
   {    for (j=0;j<ny;j++)
        {   k=i+j*nz;
            val = floor((t_rho[k]-minrho)*scale);
	    fwrite( &val,1, sizeof(val), image);
	    }
	 for (j=ny;j<oy;j++)
	 {   val=0;
	     fwrite( &val,1, sizeof(val), image);
	     }
	  }
	 fclose(image);
	 }
/*================================================*/
/*================================================*/
void swap ( P_(void *)l, P_(int) size)
#ifdef NO_PROTO
void * l;
int size;
#endif
{
#ifdef MS_DOS
     return;
#else
char * b;
char a;
switch (size)
{   case 4 : b = l;
             a = b[3]; b[3]=b[0]; b[0]=a; 
             a = b[2]; b[2]=b[1]; b[1]=a;
             return;
    case 2 : b = l;
             a = b[1]; b[1]=b[0]; b[0]=a;
    case 1 : return;
    }        
#endif
	  }
/*================================================*/
/*================================================*/

