/* XND_BAC.C      background calculation  */

#include "xnd_def.h"
#include "xnd_cah.h"

#include <string.h>

/* procedure for interpollation */
void inter_back(P_(void))
{    int   nback;
     float *pos;
     int   i,j,iod;
     float v1,v2;
     float v,hd,hh;
     float *v1_deriv,*v2_deriv;
     int *p1_deriv,*p2_deriv;
     int   calc_deriv;

     nback=l_exper->n_back;
     if (nback==0) return;
     push_err_msg("inter_back(xnd_bac.c)");
     pos = l_exper->back_pos;
     VAR_init (&l_exper->back);
     if (fini==0 && minli==0)
     {    v1_deriv = (float *) tst_alloc (ordre,sizeof(float),"back");
	  v2_deriv = (float *) tst_alloc (ordre,sizeof(float),"back");
	  p1_deriv = (int *) tst_alloc (ordre,sizeof(int),"back");
	  p2_deriv = (int *) tst_alloc (ordre,sizeof(int),"back");
	  calc_deriv = 1;
	  }
	  else calc_deriv = 0;
     j=1;
     v1 = var_valeur (0);
     v2 = var_valeur (1);
     if (calc_deriv!=0) VAR_io_id
     {   iod = io*dim+id;
         if ( (p1_deriv[iod] = var_param(0))!=0 )
		  v1_deriv[iod] = var_derive ();
	 if ( (p2_deriv[iod] = var_param(1))!=0 )
		  v2_deriv[iod] = var_derive ();
	 }
     hh = *(pos+1) - *pos;
     v = (v2-v1);
     for (i=0,l_points=l_diag->points;i<n_pts;i++,l_points++)
     {   if ( *l_points <= *pos ||  j >= nback )
	 {    put_back(i) = v1;
	      if (calc_deriv!=0) VAR_io_id
              {   iod = io*dim+id;
                  if (p1_deriv[iod])
		  dy_dp [put_dydp(i,p1_deriv[iod])] += v1_deriv[iod];
	      }   }
	 else if ( *l_points >= *(pos+1) )
	 {   v1 = v2;
	     pos++;
	     if (calc_deriv!=0) VAR_io_id
	     {   iod = io*dim+id;
	         p1_deriv[iod] = p2_deriv[iod];
		 v1_deriv[iod] = v2_deriv[iod];
		 }
	     if ( j++ <= nback)
	     {   v2 = var_valeur (j);
	         if (calc_deriv!=0) VAR_io_id
                 {   iod = io*dim+id;
		     if ((p2_deriv[iod] = var_param  (j))!=0)
		      v2_deriv[iod] = var_derive ();
		      }
		 hh = *(pos+1) - *pos;
		 v = (v2-v1);
		 }
	     i--; l_points--;
	     }
	 else
	 {    hd = (*l_points - *pos) / hh;
	      put_back (i) = v1 + v * hd;
	      if (calc_deriv!=0) VAR_io_id
              {   iod = io*dim+id;
	          if (p1_deriv[iod])
		     dy_dp[put_dydp(i,p1_deriv[iod])] += (1-hd) * v1_deriv[iod];
		  if (p2_deriv[iod])
		     dy_dp[put_dydp(i,p2_deriv[iod])] += hd * v2_deriv[iod];
	      }  }
	 }
     if (calc_deriv!=0)
     {   free (v1_deriv);
	 free (v2_deriv);
	 free (p1_deriv);
	 free (p2_deriv);
     }     
    pop_err_msg();	
    }

/* ---------------------------------------------*/
/*   procedures for spline calculation          */

static FLOAT *vec, val, *b_mat;

static FLOAT spline_val (P_(FLOAT) d)
#ifdef NO_PROTO
FLOAT d;
#endif
{    FLOAT r_val;
     r_val = ((*vec * d + *(vec+1)) * d + *(vec+2)) * d + val;
     return (r_val);
     }

static FLOAT der_spline(P_(int) j, P_(int) i, P_(FLOAT) h , P_(FLOAT) d)
#ifdef NO_PROTO
int j, i;
FLOAT h , d;
#endif
{   int   k;
    FLOAT v,*mat;
    if (d*h==0) return (0);
    if (i > j)
    { 	k = 3*i;
	mat = b_mat + (k*(k+1))/2+3*j;
	v =  (( *mat * d + *(mat+1) ) * d + *(mat+2) ) * h;
	mat += k+1;
	v = ( v + ( *mat * d + *(mat+1) ) * d * *(mat+2) ) * h;
	mat += k+2;
	v += ( *mat * d + *(mat+1) ) * d + *(mat+2);
	}
    else if (j > i)
    { 	k = 3*j;
	mat = b_mat + (k*(k+1))/2+3*j;
	v =  (( *mat * h + *(mat+1) ) * h + *(mat+2) ) * d;
	mat += k+1;
	v = ( v + ( *mat * h + *(mat+1) ) * h + *(mat+2) ) * d;
	mat += k+2;
	v += ( *mat * h + *(mat+1) ) * h + *(mat+2);
	}
    else
    { 	k = 3*j;
	mat = b_mat + (k*(k+3))/2;
	v =  *mat * h * h * d * d;
	mat += k+1;
	v += ( *mat * (h+d) + *(mat+1)) * h * d;
	mat += k+2;
	v += *mat * (h*h+d*d) + *(mat+1) * (h+d) + *(mat+2);
	}
    return (v*h*d);
    }

void spline_back(P_(void))
{    int   nback;
     float *pos, *b_pos;
     FLOAT *mat, *b_vect;
     FLOAT ha, hh, hc, d;
     int   npoly,ncom,ndim,nmat;
     int   i,ii,j,ij,ip;

     nback=l_exper->n_back;
     if  (nback<=2)     {   inter_back();  return;  }
     push_err_msg("spline_back(xnd_bac.c)");
	
/*    Calcul des splines naturelles passant par les N points Xi,Yi */
/*    Y = Ai H^3 + Bi H^2 + Ci H + Yi  avec H = X - Xi   i=0,n-2   */
/*    On note  Di = Yi+1 - Yi  et  Hi = Xi+1 - Xi                  */
/*    On ecrit derivee 1 et 2 continue, et Y" nul en 0 et n-1      */
/*    On resoud le systeme   W = M.V  ou M est symetrique lsq      */
/*    W contient A1, B1, C1, A2...                                 */

     npoly = nback-1;
     ncom  = npoly-1;
     ndim  = 3*npoly;
     nmat  = (ndim*(ndim+1))/2;
     b_vect= (FLOAT *) tst_alloc (ndim,sizeof(FLOAT),"back");
     b_mat = (FLOAT *) tst_alloc (nmat,sizeof(FLOAT),"back");

    l_points=l_diag->points;
    VAR_init (&l_exper->back);
    for (i=0, pos = l_exper->back_pos;i<npoly;i++,pos++)
     {    ha = *(pos+1) - *pos;
	  hh = ha*ha;
	  hc = hh*ha;
	  d = var_valeur(i+1) - var_valeur (i);
	  ii=3*i;
	  b_vect [ii] = hc*d;
	  b_vect [ii+1] = hh*d;
	  b_vect [ii+2] = ha*d;
	  mat = b_mat + (ii*(ii+3))/2;
	  mat[0]      += hc*hc;
	  mat[ii+1]   += hc*hh;
	  mat[ii+2]   += hh*hh;
	  mat[2*ii+3] += hc*ha;
	  mat[2*ii+4] += hh*ha;
	  mat[2*ii+5] += ha*ha;
	  if (i < ncom)
	  {   mat[2*ii+5] += 1;
	      mat[2*ii+4] += 2*ha;
	      mat[2*ii+3] += 3*hh ;
	      mat[ii+2]   += 4*ha*ha+4;
	      mat[ii+1]   += 6*hh*ha+12*ha;
	      mat[0  ]    += 9*hh*hh+36*hh;

	      mat[4*ii+10] -= 12*ha;
	      mat[4*ii+11] -= 4;
	      mat[4*ii+14] += 4;
	      mat[5*ii+15] -= 3*hh;
	      mat[5*ii+16] -= 2*ha;
	      mat[5*ii+17] -= 1;
	      mat[5*ii+20] += 1;
	      }
	  }
     b_mat[2] += 4;
     ii=3*ncom;
     mat = b_mat + (ii*(ii+3))/2;
     mat[0] += 36*hh;
     mat[ii+1] += 12*ha;
     mat[ii+2] += 4;
     i = chol_part (b_mat, b_vect, ndim);
     if (i)
     {   fprintf (list_fich," Spline back_ground : Element de matrice diagonal nul #%d\n",i);
	 for (j=0;j<ndim;j++) 
	    fprintf (list_fich," Y(%d) %g %c",
	       j, (float) b_vect[j], j%5==4?'\n':' ');
	 fprintf (list_fich,"\n");
	 for (j=0;j<nmat;j++) 
	    fprintf (list_fich," M(%d) %g %c",j, (float) b_mat[j],
                      j%5==4?'\n':' ');
	 fprintf (list_fich,"\n");
	 if (i) termine (12, "inversion Spline\n");
	 }
	
     pos = l_exper->back_pos;
    if (fini && minli == 0)
    {  fprintf(list_fich," SPLINE\n");
       for (i=0;i<npoly;i++)
        fprintf(list_fich," %2d yb = %f d3 %+f d2 %+f d %+f, d=2t-%.3f\n",
         i,(float) b_vect[3*i],(float) b_vect[3*i+1],(float) b_vect[3*i+2],var_valeur(i),pos[i]);	
        fprintf(list_fich,"\n");
	}
     val = var_valeur (0);
     vec =b_vect;
     j = 0;
     hh = 0;
     ha = *(pos+1) - *pos;
     for (ip=0,l_points=l_diag->points;ip<n_pts;ip++,l_points++)
     {   d = *l_points - *pos;
	 if ( j < ncom && d >= ha )
	 {    vec +=3;   pos++;   j++;
	      ha = *(pos+1) - *pos;
	      val = var_valeur (j);
	      ip--;     l_points--;
	      continue;
	      }
	 put_back (ip) = spline_val ( d);
	 if (fini==0 && minli==0)
	  for (i=0, b_pos = l_exper->back_pos;i<nback;i++,b_pos++)
	   VAR_io_id
	    if ((ij=var_param (i))!=0)
	    {   hh = *(b_pos+1) - *b_pos;
	        if (i == 0) hc = 0;
		else  hc = der_spline (j , i-1, hh, d);
		if (i!= npoly) hc -= der_spline (j, i, hh , d);
		if (i == j) hc += 1;
		dy_dp[put_dydp(ip,ij)] += hc * var_derive();
		}
	 }
     free (b_vect);
     free (b_mat);
    pop_err_msg();	
     }

/* ---------------------------------------------*/
/*   interface procedure                        */
void ini_back_ground(P_(void))
{     
    push_err_msg("ini_back_ground(xnd_bac.c)");
    back_ground = (back_mode == 0) ? inter_back  : spline_back ;
    pop_err_msg();	
    }
/* ---------------------------------------------*/
