/*  xnd_def.h    definitions generales */
/*  les principales dependances du site */

/* if you prefer double instead of float in derivatives ...*/
/* this parameter has to be set to 1, 0 either */ 
#define DOUBLEFLOAT 0 

#ifdef __TURBOC__
/* les compilateurs borland sur PC  Borlandc ou turboc*/
/* automatique, modele de memoire utilisee : LARGE */
#define  MS_DOS
#define  OS_CHECK_ABORT
#define  MAX_ALLOC 65520L      /* 64kO-16 for PC */
#define  CLOCK_UNIT 0.001
#define  MATHERR
#define  END_PATH_STR   "\\"

#else
#ifdef VAXC                    /* argument du compilation */
/* compilation sur VAX sous VMS */
#define  MAX_ALLOC 2000000L    /* 2Mo dans le meme tableau */
#define  END_PATH_STR   "]"
#define  unlink    delete      /* le compilateur n'utilise pas le nom std */

#else
#ifdef __SC__                  /* Symantec C pour Mac  */
#define MAC_OS
#define  MAX_ALLOC 512000L      /* 512kO  */
#endif 
#ifdef THINK_C                /* compilateur ThinkC sur Mac */
#define MAC_OS
#define  MAX_ALLOC 256000L      /* 256kO  */
#define  CONSTANTE_PURE         /* pas d operations dans les constantes d initialisation */
#endif

#ifdef    MAC_OS
#define  OS_CHECK_ABORT
#define  END_PATH_STR   ":"
#include <stdlib.h>

#else
/* assuming we are unix now */
#define UNIX_OS
#define  END_PATH_STR   "/"
#define  NAME_LG        180

#ifndef __STDC__
#define  NO_PROTO          /* ANSI prototypes not known in K.R. C */
#endif

#ifndef CLOCK_UNIT
#define CLOCK_UNIT 0.000001
#endif


#endif
#endif
#endif
/* end of dependencies configuration related to operating system */

/* allow KR or ANSI compilation */
#ifdef   NO_PROTO
#define  PROTO(a)  ()
#define  P_(a)
#else
#define  PROTO(a)  a
#define  P_(a)     a
/* includes also stdlib wich is not know in KR */
#include <stdlib.h>    
#endif

#include <stdio.h>
#include <math.h>

#ifdef MSDOS
#include <values.h>
#endif

#ifdef UNIX_OS
#include <values.h>
#endif


#if (DOUBLEFLOAT)
#define FLOAT  double
#else
#define FLOAT  float
#endif

#define DYDP_NB          4  /* stored io, w, ic, ib then  param=1 , param=2  */
#ifndef MAX_ALLOC           /* en augmentant cette valeur la gestion */
#define MAX_ALLOC 6400000L  /* des gros fichiers passe au syst de pagination */
#endif
#ifndef NAME_LG
#define NAME_LG      80	    /* string slength */
#endif
#define  ERROR   "\n XND_ERROR"


#define  SYM_ID       20	/* sym grp name */
#define  MAX_LAMBDA   50
#define  MAX_ASSYM     6	/* higher asym expansion */
#define  MAX_DIM_MODUL 3        /* dimension suppl en phase modul */
#define  MAX_ORIEN     5        /* higher expansion in orien */

#define  MAX_DIF     200  	/* used in lecture phase */
#define  MAX_SYM     200
#define  MAX_COD    2000
#define  CHK_VAL   (-999.99)
#define  NB_INCOM      5   /* nb pts d'integration incom par defaut */

      /* chemin d'acces au fichier *.d */
#define  PROG_PATH ""            /* automatique par argv[0] */

#define  PRG_ID    "xnd"
#define  DOC_ID    "xnd_doc.d"
#define  DIF_FILE  "xnd_dif.d"
#define  SYM_FILE  "xnd_sym.d"

#define EXPER_RX       1
#define EXPER_N        2
#define EXPER_ANO      4
#define EXPER_MAG      8
#define EXPER_RXA (EXPER_RX | EXPER_ANO)
#define EXPER_NM  (EXPER_N  | EXPER_MAG)
#define EXPER_SINGLE_CRYSTAL 16

#define PHASE_GENERE    0
#define PHASE_HKL_LU    1
#define PHASE_AMORPHE  -1
#define PHASE_PARASITE -2
#define PHASE_QUASI    -3
#define PHASE_MAGNET   -4
#define PHASE_MODUL    -5

#define DIF_COMPTON     1
#define DIF_TDS_ISO     2
#define DIF_TDS_PIC     4

#define PLG_NHEADER     2
#define PLG_ADDEND      4
#define PLG_ADDSEMI     8

/* drapeau de nature des atomes ou masque */
#define B_ANISO   1
#define MAGNET    2
#define MODUL     (4+8+16)
#define NATURE_MAX (31)

#define  EPSILON_ANOMAL 0.0002

 /* this to create or declare the variable as extern  */
#ifndef EXTERN
#define EXTERN    extern
#define EXTERN_NOT_SPACE
#endif

/* pour les divers type de variables a lire ou ecrire */
#define VAR_STD    0
#define VAR_BG     1
#define VAR_ATOM   2
#define VAR_ORIEN  3
#define VAR_HKL    4
#define VAR_RADIAL 5

/* dimension for */
#define  INSTRU   4
#define  ASSYM    3
#define  LAMBDA   4
#define  REGLAGE  6
#define  BACK     1
#define  ORIEN    3
#define  ECH      2
#define  TRANSIT  3
#define  CELL     7
#define  PROF     6
#define  PASSYM   2
#define  BCOOR    6
#define  VECTEUR  3
#define  AMODUL   8
#define  DIF      2
/* selon les divers types d'atomes possibles */
#define  COORD_0    5
#define  COORD_ANIS 5
#define  COORD_MAGN 3
#define  COORD_MAX  (COORD_0+COORD_ANIS+COORD_MAGN)
#define  COORD_DIM  (1+COORD_MAX)
/* code interne des variables a affiner */
#define NUMER_X   0
#define NUMER_B   5
#define NUMER_K   (NUMER_B+COORD_ANIS+1)
#define NUMER_A   (NUMER_K+COORD_MAGN)

#define PROF_ANG   4
#define ORIEN_ANG  1
#define ORIEN_PROF (5+MAX_ASSYM)
#define  DISTRI   2

#include "xnd_typ.h"
#include "xnd_vah.h"
#include "xnd_fun.h"
#include "xnd_msg.h"

/* redefinition eventuelle, valeurs compatibles VAX... */

#ifndef  MAXFLOAT
#define  MAXFLOAT 1.7E+38
#endif
#ifndef  MINFLOAT
#define  MINFLOAT 8.43E-37
#endif

#define  EPSILON  1.0E-25	/* in some tests */
#ifndef  LN_MAXFLOAT
#define  LN_MAXFLOAT  88.0	/* ln(MAXFLOAT) */
#endif

#ifndef RAND_MAX
#define RAND_MAX 0xFFFFl
#endif

/* values for math constants .... to the end of the file */
/* Constants rounded for 21 decimals. */
#ifndef M_E
#define M_E		2.71828182845904523536
#endif
#ifndef M_LOG2E
#define M_LOG2E		1.44269504088896340736
#endif
#ifndef M_LOG10E
#define M_LOG10E	0.434294481903251827651
#endif
#ifndef M_LN2
#define M_LN2		0.693147180559945309417
#endif
#ifndef M_LN10
#define M_LN10		2.30258509299404568402
#endif
#ifndef M_PI
#define M_PI	 	3.14159265358979323846
#endif
#ifndef M_2PI
#define M_2PI	 	6.28318520717958647692
#endif
#ifndef M_PI_2
#define M_PI_2		1.57079632679489661923
#endif
#ifndef M_PI_4
#define M_PI_4		0.785398163397448309116
#endif
#ifndef M_1_PI
#define M_1_PI		0.318309886183790671538
#endif
#ifndef M_2_PI
#define M_2_PI		0.636619772367581343076
#endif
#ifndef M_1_SQRTPI
#define M_1_SQRTPI	0.564189583547756286948
#endif
#ifndef M_2_SQRTPI
#define M_2_SQRTPI	1.12837916709551257390
#endif
#ifndef M_SQRT2
#define M_SQRT2		1.41421356237309504880
#endif
#ifndef M_SQRT_2
#define M_SQRT_2	0.707106781186547524401
#endif

/* -------------------------------------------------------- */

#define  RAD            ( M_PI / 180.0 )
#define  M_GOLD         1.618033989

#define M_2LN2		(2*M_LN2)
#define M_4LN2		(4*M_LN2)
#define M_SQRT4LN2	 sqrt(4*M_LN2)

/* -------------------------------------------------------- */



