 /* XND_MET.C metrique, multiplicite, holoedre, extiction */

#include "xnd_def.h"

/* -----------   metric calculation -------------------------- */
static float  a_par,b_par,c_par,det;
static float  cosa,cosb,cosc,sina,sinb,sinc;
static float  cosab_c,cosbc_a,cosac_b;

float ini_metrique (P_(void))
{    float n;
     if (l_phase->nature == PHASE_AMORPHE) return 1.0;
    VAR_init (&l_phase->cell);
     a_par = var_valeur(1);
    if ( l_phase->nature == PHASE_QUASI ) 
    {    if (a_par > 0) g_aa = 1.0 / (a_par*a_par);
         return (a_par);
         }

     b_par = var_valeur(2);
     c_par = var_valeur(3);
     cosa = cos ( RAD * var_valeur(4));
     if (fabs(cosa) <EPSILON) cosa = 0;
     sina = sqrt ( 1.0 - cosa * cosa);
     cosb = cos ( RAD * var_valeur(5));
     if (fabs(cosb) <EPSILON) cosb = 0;
     sinb = sqrt ( 1.0 - cosb * cosb);
     cosc = cos ( RAD * var_valeur(6));
     if (fabs(cosc) <EPSILON) cosc = 0;
     sinc = sqrt ( 1.0 - cosc * cosc);
     d_aa = a_par*a_par;
     d_bb = b_par*b_par;
     d_cc = c_par*c_par;
     d_ab = 2 * a_par*b_par*cosc;
     d_ac = 2 * a_par*c_par*cosb;
     d_bc = 2 * b_par*c_par*cosa;
     det= 1+2*cosa*cosb*cosc-cosa*cosa-cosb*cosb-cosc*cosc;
     g_aa = sqr(sina/a_par) /det;
     g_bb = sqr(sinb/b_par) /det;
     g_cc = sqr(sinc/c_par) /det;
     g_ab = (cosab_c = 2*(cosa*cosb-cosc)) /(a_par*b_par*det);
     g_ac = (cosac_b = 2*(cosc*cosa-cosb)) /(a_par*c_par*det);
     g_bc = (cosbc_a = 2*(cosb*cosc-cosa)) /(b_par*c_par*det);
     na_b = g_ab * g_ac - 2 * g_cc * g_bc;
     nb_b = 4 * g_aa * g_cc -  g_ac * g_ac;
     nc_b = g_ab * g_ac - 2 * g_aa * g_bc;
     n =  (na_b * g_aa + nb_b * g_ab + nc_b * g_ac) * na_b;
     n += (nb_b * g_bb + nc_b * g_bc) * nb_b + nc_b * nc_b *g_cc;
     n = sqrt (n);
     na_b /= n;
     nb_b /= n;
     nc_b /= n;
     return(sqrt(det));
     }

/*  ---------------------------------------------------------------- */
/*  pour chaque raie en utilisant :
    dg_aa/da = -2g_aa/a;          dg_ab/da = -g_ab/a;
    dg_bb/da = 0;                 dg_bc/da = 0;
    */
void ini_d_metrique (P_(void))
{   float dt_dq;
    float d_det, ss;
    extern int cas_mag_mod;
    push_err_msg("ini_d_metrique");
    switch  ( l_phase->nature )
    {   case  PHASE_PARASITE : 
              /* direct dans xnd_cal.c car pas de maille */
              break;
        case  PHASE_QUASI : 
              dt_dq = 0.5 / RAD * tan_t / q;
              d_metrique[0] = - dt_dq * 2 * g_aa * h_eff / a_par;
              break;
        default :
        dt_dq = 0.5 / RAD * tan_t / q;
        d_metrique[0] = - dt_dq * h_eff * (2*h_eff*g_aa + k_eff*g_ab + l_eff*g_ac) / a_par;
        d_metrique[1] = - dt_dq * k_eff * (2*k_eff*g_bb + h_eff*g_ab + l_eff*g_bc) / b_par;
        d_metrique[2] = - dt_dq * l_eff * (2*l_eff*g_cc + l_eff*g_ac + k_eff*g_bc) / c_par;
        d_det = sina * cosbc_a / det;
        ss = h_eff*h_eff*g_aa*cosa/sina;
        ss += sina*(k_eff*l_eff/(b_par*c_par) - h_eff*(k_eff*cosb/b_par + l_eff*cosc/c_par)/a_par)/det;
        d_metrique[3] = RAD * dt_dq * (ss + q * d_det);
        d_det = sinb * cosac_b / det;
        ss = k_eff*k_eff*g_bb*cosb/sinb;
        ss += sinb*(h_eff*l_eff/(a_par*c_par) - k_eff*(h_eff*cosa/a_par + l_eff*cosc/c_par)/b_par)/det;
        d_metrique[4] =  RAD * dt_dq * (2*ss + q * d_det);
        d_det = sinc * cosab_c / det;
        ss = l_eff*l_eff*g_cc*cosc/sinc;
        ss += sinc*(h_eff*k_eff/(a_par*b_par) - l_eff*(h_eff*cosa/a_par + k_eff*cosb/b_par)/c_par)/det;
        d_metrique[5] = RAD * dt_dq * (ss + q * d_det);
        if ( (l_phase->nature  == PHASE_MAGNET ||
              l_phase->nature == PHASE_MODUL) && cas_mag_mod & 6) 
                                   ini_d_vecteur( dt_dq );
        }
    pop_err_msg();
    }
/* ------------------------------------------------------- */
/* valeurs et derivees dans reseau direct pour contraintes */
float  scalaire (P_(float *)u, P_(float *)gv, P_(float *)v)
#ifdef NO_PROTO
float *u, *gv, *v;
#endif
{    float d;
    int j;
    gv[0] = d_aa * v[0] + (d_ab * v[1] + d_ac * v[2]) /2;
    gv[1] = d_bb * v[1] + (d_bc * v[2] + d_ab * v[0]) /2;
    gv[2] = d_cc * v[2] + (d_ac * v[0] + d_bc * v[1]) /2;
    d=0;
    for (j=0;j<3;j++) d += u[j] * gv[j];
    return (d);
    }

float  b_equiv (P_(VAR *)x)
#ifdef NO_PROTO
VAR *x;
#endif
{    float b;
    ini_metrique();
    VAR_init(x);
    b = d_aa * var_valeur(4) + d_bb * var_valeur(5) + d_cc * var_valeur(6);
    b += d_ab * var_valeur(7) + d_ac * var_valeur(8) + d_bc * var_valeur(9);
    b *= 4/3.0;
    return (b);
    }

float d_dmetric (P_(int) j, P_(float *)u, P_(float *)v)
#ifdef NO_PROTO
int j;
float *u, *v;
#endif
{    switch (j)
    {      case 1 : return ( u[0] * v[0] * d_aa + (u[0]*v[1]+u[1]*v[0])*d_ab + (u[0]*v[2]+u[2]*v[0]*d_ac) / a_par);
          case 2 : return ( u[1] * v[1] * d_bb + (u[0]*v[1]+u[1]*v[0])*d_ab + (u[1]*v[2]+u[2]*v[1]*d_bc) / b_par);
          case 3 : return ( u[2] * v[2] * d_aa + (u[2]*v[1]+u[1]*v[2])*d_bc + (u[0]*v[2]+u[2]*v[0]*d_ac) / c_par);
      case 4 : return ((u[2]*v[3]+u[3]*v[2]) * b_par *c_par * sinc * RAD);
      case 5 : return ((u[2]*v[3]+u[3]*v[2]) * b_par *c_par * sinc * RAD);
      case 6 : return ((u[2]*v[3]+u[3]*v[2]) * b_par *c_par * sinc * RAD);
        }  
    return 0;
    }
    
 /* ---------------------------------------------------------- */

int multiplicite (P_(void))
{                           /* TIC I p32 */
    switch (systeme)
    {   case 'C' : if ( (H==0 && K==0) || (K==0 && L==0) || (L==0 && H==0)) return(6);
           if ( H==0 || K==0 || L==0)
           {  if (H==K || H+K==0 || K==L || K+L==0 || L==H || L+H==0)  return (12);
              if (l_symgrp->holoedre) return (24);
              return(12);
              }
           if ( H==K && K==L) return (8);
           {  if (H==K || H+K==0 || K==L || K+L==0 || L==H || L+H==0)  return (24);
              if (l_symgrp->holoedre) return (48);
              return(24);
              }
    case 'Q' : if (H==0 && K==0) return (2);
           if (L==0)
           {    if ( H==0 || K==0 || H==K || H+K==0) return (4);
            if (l_symgrp->holoedre) return (8);
            return (4);
            }
           {    if ( H==0 || K==0 || H==K || H+K==0) return (8);
            if (l_symgrp->holoedre) return (16);
            return (8);
            }
    case 'H' : if (H==0 && K==0) return (2);
           if ( H==0 || K==0 || H==K || H+K==0 || 2*H+K==0 || H+2*K==0)
           {    if (L==0) return (6);
            return (12);
            }
           if (L==0)
           {   if (l_symgrp->holoedre) return(12);
               return (6);
               }
           if (l_symgrp->holoedre) return(24);
           return (12);
    case 'R' : if (H==0 && K==0) return (2);
      /* axe H */  if ( H==0 || K==0 || H==K || H+K==0 || 2*H+K==0 || H+2*K==0)
      /* -3M1 */       return(6);
           if (l_symgrp->holoedre) return(12);
           return (6);
    case 'T' : if ( H==K && K==L) return(2);
      /* axe R */  if (H==K || K==L || L==H) return(6);
                 if (H+K==0 || K+L==0 || L+H==0) 
                 {  if ((H + K + L != 0) && l_symgrp->holoedre) return (12);
              return(6);
              }
           if (l_symgrp->holoedre) return (12);
           return(6);
    case 'O' : if ( (H==0 && K==0) || (K==0 && L==0) || (L==0 && H==0)) return(2);
           if ( H==0 || K==0 || L==0) return(4);
           return(8);
    case 'M' : if ( (H==0 && K==0) || (K==0 && L==0) || (L==0 && H==0)) return(2);
           if ( K==0 ) return(2);
           return(4);
    case 'N' : if ( (H==0 && K==0) || (K==0 && L==0) || (L==0 && H==0)) return(2);
           if ( L==0 ) return(2);
           return(4);
    case 'L' : if ( (H==0 && K==0) || (K==0 && L==0) || (L==0 && H==0)) return(2);
           if ( H==0 ) return(2);
           return(4);
    case 'A' : return (2);
    }
    return(0);
     }

 /* ---------------------------------------------------------- */

void gen_holoedre (P_(void))
{   int ho,ko,lo;
    ho = H;
    ko = K;
    lo = L;
    switch (systeme)
    {   case 'C' : if ( (H==0 && K==0) || (K==0 && L==0)|| (L==0 && H==0))    return;
           if ( H==0 || K==0 || L==0)
           {  if (H==K || H+K==0 || K==L || K+L==0 || L==H || L+H==0) return;
              H = ko; K = ho;  break;
              }
           if ( H==K && K==L) return;
           {  if (H==K || H+K==0 || K==L || K+L==0 || L==H || L+H==0)  return;
              H = ko; K = ho;  break;
              }
    case 'Q' : if (H==0 && K==0) return;
           if (L==0)
           {    if ( H==0 || K==0 || H==K || H+K==0) return;
            H = ko; K = ho;  break;
            }
           {    if ( H==0 || K==0 || H==K || H+K==0) return;
            H = ko; K = ho;  break;
            }
    case 'H' : if (H==0 && K==0) return;
           if ( H==0 || K==0 || H==K || H+K==0 || 2*H+K==0 || H+2*K==0) return;
           H = ko; K = ho;  break;
    case 'R' : if (H==0 && K==0) return;
    /* axe H */ if ( H==0 || K==0 || H==K || H+K==0 || 2*H+K==0 || H+2*K==0) return;
                H = ko; K = ho;  break;
    case 'T' : if ( H==K && K==L) return;
    /* axe R */ if ( H+K+L==0 )
           {  if (H==K || H+K==0 || K==L || K+L==0 || L==H || L+H==0)  return;
           H = ko; K = ho;  break;
              }
           if (H==K || K==L || L==H)  return;
           H = ko; K = ho;  break;
    case 'O' :
    case 'M' :
    case 'N' :
    case 'L' :
    case 'A' : return;
    }
    exist_hkl (0);
    H = ho;
    K = ko;
    L = lo;
    }

 /* ---------------------------------------------------------- */

int extinction (P_(void))
{   switch (bravais)
    {   case 'A' : return ((K+L)%2);
    case 'B' : return ((L+H)%2);
    case 'C' : return ((H+K)%2);
    case 'I' : return ((H+K+L)%2);
    case 'F' : return (abs(K+L)%2 + abs(L+H)%2);
    case 'R' : return ((K-H+L)%3);
    case 'S' : return ((H-K+L)%3);
    case 'H' : return ((H-K)%3);
    case 'P' : return (0);
    }
    return(1);
    }
