/* XND_PRT.C       listing  */

#include "xnd_def.h"
#include <string.h>
#include <ctype.h>

/* ------------------------------------------------------------------ */
/* this procedure allows a common format for its parameters */

#define TOT_DIGITS 11
#define MIN_PRINT  (1.0E6*MINFLOAT)
static void printformat  ( P_(float) a, P_(float) b, P_(float) c, P_(float) signif )
#ifdef NO_PROTO
float a, b, c;
float signif;
#endif
{
    int range;
    int value;
    int lga;
    int level=0;
    int digits;
	 int tot;
    float shift;
    char  msg[20];

    push_err_msg("format(xnd_prt.c)");
    if ( signif > MIN_PRINT ) range = floor (log10 (signif) - 1);
    else
    {    range = 0;
         fprintf(list_fich, "  XND_ERROR printformat : signif(%g) <~ 0\n", signif);
        }
    lga =  (fabs(a) > MIN_PRINT ) ? floor(log10(fabs(a))) : floor(log10(MIN_PRINT));



/*fprintf(list_fich,"\n\n range %d  lga %d level    shift   , a %g\n", range,lga,a); */
    if ( ( lga < 0 && range < -TOT_DIGITS )  || ( lga > 0 && range > 0 ) )
    {   level = lga;
        shift = pow((double)10.0, (double) level);
        a /= shift;
	b /= shift;
	c /= shift;
        range -=lga;
	lga -= lga;
        }
    value =  lga > 2-TOT_DIGITS ? lga:  2-TOT_DIGITS;
    digits = value - range;
    if (digits < 2)  { digits = 2; range = value - digits; } 

/*fprintf(list_fich," range %d value %d digits %d lga %d level %d shift %g, a %g\n", 
range,value,digits,lga,level, shift, a);*/


   if (lga > 0)  digits = ( digits > lga)  ?  digits - lga : 0 ; 
        else  if (lga != 0) digits -= lga;
   tot =  (digits <= TOT_DIGITS) ? TOT_DIGITS : digits;
   if ( tot > TOT_DIGITS )
       fprintf(list_fich,"debug info range %d value %d digits %d lga %d level %d shift %g, a %g\n                          ", 
range,value,digits,lga,level, shift, a);

   

   if (level ) sprintf (msg,"e%+03d" , level);  else strcpy(msg,"    ");
   fprintf (list_fich," % #*.*f%s % #*.*f%s % #*.*f%s",
	   tot, digits, a, msg, tot, digits, b, msg,
	   tot, digits, c, msg);

   pop_err_msg();
   }
/* ------------------------------------------------------------------ */
/*    meme definition des cas que dans xnd_rvar.c VAR cf xnd_def.h    */
static void fput_var ( P_(VAR *) var, P_(int) arg,
	P_(char *) nature, P_(char **) cle)
#ifdef NO_PROTO
VAR *var;
int arg;
char * nature;
char **cle;
#endif
{    int   i,n,m,mm;
     int   premier = 0;
     float valeur, shift, deplac, sigma, sval, dval;
     float signif;
     HKL *p_hkl;
     float *pos;
     int ncle;

   if (var->size==0) return;
    push_err_msg ("fput_var");
   switch (arg)
     {    case VAR_BG     : pos = l_exper->back_pos;       break;
	  case VAR_HKL    : p_hkl = l_phase->hkl;          break;
          case VAR_RADIAL : pos = l_radial->diff_pos;      break;
	  }
     ncle=var->ncle;
     VAR_init (var);
     for (i=0;i<var->size;i++)
     {   for (io=0;io<ordre;io++)
	 {   deplac = sigma = 0;
	     m = mm = 0;
	     for (id=0;id<dim;id++)
	     if ((n=var_param(i))!=0)
	     {   shift = var_shift();
	         dval = y_vect[n-1];
		 sval =	 matrice[(n*(n+1))/2-1];
	         deplac += shift * dval;
		 sigma  += shift * shift * val_sigma * sval;
		 if (m) mm=1;
		 m += n;
 		 }
	     if (m)
	     {   if (minli==0 || minli==-1)
	     {   if (mm==0) fprintf(list_fich," %3d",m);
	         fprintf(list_fich,"%s  %8s",mm==0?"":"   *",
                            (premier++==0)?nature:"");
	         switch (arg)
	     {   case VAR_BG     : 
		 case VAR_RADIAL : 
                       fprintf(list_fich," %8.3f",pos[i]);   
                       break;
		 case VAR_STD    : 
                       fprintf(list_fich," %8s",cle[i%ncle]);     
                       break;
		 case VAR_ATOM   : 
                       fprintf(list_fich," %8s",txt_atom[coord_index(i%ncle)]);
                       break;
		 case VAR_ORIEN  : 
                       fprintf(list_fich," %2d_%5s",i/ncle,cle[i%ncle]);
                       break;
		 case VAR_HKL    : 
                       fprintf(list_fich,"%3d%3d%3d",
                           p_hkl[i].h[0], p_hkl[i].h[1], p_hkl[i].h[2]);     
                       break;
		 }
	        if (sigma<0) fprintf(list_fich,"Error sigma<0 %f\n",sigma);
	        sigma = sqrt(fabs(sigma));
	        if (minli==- 1) var_new(deplac*opt_deplace);
                valeur = var_new(deplac);
                signif = eps_stop*sigma;
	        fprintf(list_fich," (%d) ", io);
	/*  fprintf(list_fich," (%d) %12.6g %9.3g %9.3g",io,var_new(deplac),deplac,sigma); */
                printformat (valeur, deplac, sigma, signif);
	        if (fabs(deplac)>signif)  fini=0;
		    else   fprintf(list_fich," *");
	        fprintf(list_fich,"\n");
	       } 
	      else 
	      {   var_new(deplac); 
	          if (fabs(deplac)>eps_stop*sigma)  fini=0;
	          }
	     } /* if (m) */
	     } /* for io */
	  }
    pop_err_msg();
      }


/* ------------------------------------------------------------------ */
void fput_magnet_hkl (P_(TMODUL *) magnet)
#ifdef NO_PROTO
TMODUL * magnet;
#endif
{
    SATEL *satel;
    int i, nb_sat;
    char txt[8];
  
    nb_sat = magnet->nb_sat;
    satel = magnet->satel;

    for (i=0; i<nb_sat; i++, satel++) if (satel->nb_hkl > 0)
    {   sprintf (txt,"HKL #%d",i);
	fput_var (&satel->intens,VAR_HKL,txt,txt_dist);
        }
    }
/* ------------------------------------------------------------------ */

void imprime (P_(void))
{    int    i,i_phase,j;
	DIST *p_dist, *p_angl;
	char * entete;

	push_err_msg("Printing cycle results");
	entete =
"  #     variable       (o)      valeur          deplac.          sigma\n";
	fini = 1;
    for (i=0,l_exper = exper;i<n_exper;(i++,l_exper++))
    {   if (minli==0 || minli==-1)
	       fprintf(list_fich," EXPER : %s\n%s", l_exper->nom, entete);
	fput_var (&l_exper->onde,VAR_STD, T_LAMBDA, txt_onde);
	fput_var (&l_exper->back, VAR_BG, T_BACK, NULL);
	fput_var (&l_exper->reglage,VAR_STD,T_REGLAGE, txt_reglage);
	fput_var (&l_exper->instru,VAR_STD,T_INSTRU, txt_instru);
	fput_var (&l_exper->assym,VAR_ORIEN,T_ASSYM, txt_assym);
	}
    for (i_phase=0,l_phase = phase;i_phase<n_phase;i_phase++,l_phase++)
    {   if (minli==0 || minli==-1)
	       fprintf(list_fich," PHASE : '%s'\n%s", l_phase->nom, entete);
	fput_var (&l_phase->ech,VAR_STD,T_ECHELLE, txt_ech);
	fput_var (&l_phase->transit,VAR_ORIEN,T_TRANSIT, txt_transit);
	fput_var (&l_phase->cell,VAR_STD,T_CELL, txt_cell);
	if (l_phase->nature >= PHASE_GENERE ||
            l_phase->nature == PHASE_MAGNET || l_phase->nature == PHASE_MODUL )
	{   if (l_phase->nature == PHASE_MAGNET )
                fput_var (&(l_phase->magnet)->vecteur, VAR_STD, "Vecteur", txt_vecteur);
	    if (l_phase->nature == PHASE_MODUL )
                fput_var (&(l_phase->modul)->vecteur, VAR_STD, "Vecteur", txt_vecteur);

	    fput_var (&l_phase->orien,VAR_ORIEN,T_ORIEN,txt_orien);
	    fput_var (&l_phase->prof,VAR_ORIEN,T_PROFIL,txt_prof);
	    fput_var (&l_phase->assym,VAR_ORIEN,T_PROFIL,txt_passym);
	    if (l_phase->nb_atom)
	    {   for (j=0,l_atom=l_phase->atom;j<l_phase->n_atom;j++,l_atom++)
		{  fput_var (&l_atom->x,VAR_ATOM, l_atom->nom,NULL);
		   if (l_atom->n_modul)
		      fput_var (&l_atom->modul,VAR_ORIEN, l_atom->nom, txt_modul);
		   }
		if (l_phase->nb_bloc)
		{   fput_var(&l_phase->bloc,3,T_BLOC,txt_bloc);
		    for (i=0;i<l_phase->nb_bloc;i++)
		    {  for (j=0,l_atom=l_phase->bl_ortho[i];
			     j<l_phase->bl_atom[i];j++,l_atom++)
		       fput_var(&l_atom->x,VAR_ATOM,l_atom->nom,NULL);
		       if ( l_atom->n_modul) fput_var(&l_atom->modul,VAR_STD,l_atom->nom,txt_modul);
	  	    }
		}
	    if (l_phase->uncoherent)
	    {    fput_var(&l_phase->dif_ech,VAR_STD,"TdS",txt_difech);
	         if (l_phase->uncoherent&DIF_TDS_PIC)
	           fput_var(&l_phase->tds,VAR_HKL,"TdS",txt_dif);
	         }
	    if (l_phase->nb_bond)
		{   p_dist = l_phase->dist;
		    for(i=0;i<l_phase->nb_dist;i++,p_dist++)
		    fput_var (&p_dist->dist,VAR_STD,T_DIST,txt_dist);
		    p_angl = l_phase->angl;
		    for(i=0;i<l_phase->nb_angl;i++,p_angl++)
		    fput_var (&p_angl->dist,VAR_STD,T_ANGLE,txt_dist);
		    }
		}
	     else
             switch (l_phase->nature)
	{   
             case PHASE_MAGNET : fput_magnet_hkl (l_phase->magnet);
                break;
             case PHASE_MODUL  : fput_magnet_hkl (l_phase->modul);
                break;
             default : fput_var (&l_phase->intens,VAR_HKL,T_HKL,txt_dist);

                }


	     }
	else switch (l_phase->nature)
	{   case PHASE_AMORPHE :
	    l_radial = l_phase->radial;
	    for (i=0;i<l_phase->nb_dist;i++,l_radial++)
	      fput_var (&l_radial->distrib,VAR_RADIAL,T_RADIAL,NULL);
	    break;
	    case PHASE_PARASITE :
	    fput_var (&l_phase->prof,VAR_ORIEN,T_PROFIL,txt_prof);
	    fput_var (&l_phase->intens,VAR_STD,T_HKL,txt_dist);
	    break;
	    case PHASE_QUASI :
	    fput_var (&l_phase->prof,VAR_STD,T_PROFIL,txt_prof);
	    fput_var (&l_phase->intens,VAR_HKL,T_HKL,NULL);
	    }
	 }
	fflush (list_fich); 
    pop_err_msg();
     }

/* ------------------------------------------------------------------ */
void prt_b_equiv(P_(void))
{   int i,j,k,im,it;
	fprintf(list_fich,"\n");
	for (i=0,l_phase = phase;i<n_phase;i++,l_phase++)
	if (l_phase->n_atom)
	{   k = 0;
	    for (j=0,l_atom=l_phase->atom;j<l_phase->n_atom;j++,l_atom++)
	    if (l_atom->nature & 1) k++;
	    if (k==0) break;
	    
	    fprintf(list_fich," PHASE : '%s' a ",l_phase->nom);
	    for (im=0,l_exper=exper;im<n_exper;im++,l_exper++)
            for (it=0,l_diag=l_exper->diag;it<l_exper->n_diag;it++,l_diag++)
  	    fprintf(list_fich,"  %.3f",l_diag->temp);
  	    fprintf(list_fich,"\n");
     
	    temp = &temp_phase;
	    for (j=0,l_atom=l_phase->atom;j<l_phase->n_atom;j++,l_atom++)
	    if (l_atom->nature & 1)
	    {   fprintf(list_fich," %6s B_equiv (8*Pi2*u2) : ",l_atom->nom);
		for (im=0,l_exper=exper;im<n_exper;im++,l_exper++)
                for (it=0,l_diag=l_exper->diag;it<l_exper->n_diag;it++,l_diag++)
  		{   temp_phase = l_diag->temp - l_phase->temp_orig;
 		    fprintf(list_fich,"  %8.4f",b_equiv(&l_atom->x));
  		    }
  		fprintf(list_fich,"\n");
		}
	     }
	}
void prt_correl(P_(void))
{    int i,j,ii;
     int n = 0;
     int m = 0;
     float si,sj,sij;
     float niveau;
     if (n_par==1) return;
     fprintf (list_fich,"\n Correlations %d parametres\n",n_par);
     if (prt_cor>1)
     {    niveau = prt_cor / 10.0;
	  fprintf (list_fich," Valeurs superieures a %f (prt_corel = %d)\n",niveau,prt_cor);
	  }
     else niveau = 0;
     for (i=0;i<n_par;i++)
     {   ii = (i*(i+1))/2;
	 si = matrice[ii+i];
	 for (j=0;j<i;j++,n++)
	 {    sj = matrice[(j*(j+1))/2+j];
	      sij= matrice[ii+j] / sqrt(si*sj);
		  if (prt_cor==1 || fabs(sij)>niveau)
	      {    m++;
			   fprintf (list_fich," %3d %3d  %+6.3f%s",j+1,i+1,sij,(m % 5 == 4) ? "\n" : "    ");
	      }   }
	 }
     fprintf (list_fich,"\n");
	 }
