/* XND_RPHA.C     this file read all data for phases except crystal */

#include "xnd_def.h"
#include "xnd_rdh.h"

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */

static void check_dif (P_(char *)espece_lue)
#ifdef NO_PROTO
char *espece_lue;
#endif
{    char espece[11];
	char *p_esp;
	l_atom->xdif = l_atom->ndif = l_atom->mdif = l_atom->uxdif = l_atom->undif = NULL;
        l_atom->adif = NULL;
	if (lect->nature & LECT_NAT_RX)
	{   strcpy (espece,"0");
	    strcat (espece,espece_lue);
	    p_esp = espece+1;
	    while (isdigit(*p_esp)) p_esp++;
	    l_atom->xdif = get_dif(p_esp,1);
	    if (lect->nature & LECT_NAT_RXA) l_atom->adif = get_adif(p_esp);
	    if (l_phase->uncoherent & DIF_COMPTON)
	    {    p_esp--;
	        *p_esp='@';
		l_atom->uxdif = get_dif(p_esp,1);
		}
	    }
	if (lect->nature & LECT_NAT_N)
	{       strcpy (espece,"0");
	        strcat (espece,espece_lue);
		p_esp = espece+1;
		while (isalpha(*p_esp)) p_esp++;
		*p_esp=0;
		p_esp = isalpha(espece[1]) ? espece : espece+1;
		l_atom->ndif = get_dif(p_esp,1);
		if (lect->nature & LECT_NAT_NM)
	        espece[0]='_';
		p_esp = espece;
		l_atom->mdif = get_dif(p_esp,0);
		if (l_phase->uncoherent & DIF_COMPTON)
	        {   espece[0]='$';
		    l_atom->undif = get_dif(p_esp,1);
		}
	    }	
	}

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
void fget_amorphe (P_(void))
{   int i,j,n;

	fscanf (coord_fich,"%d", &l_phase->nb_dist);
	fprintf (list_fich,"  %d distrib_radiales\n", l_phase->nb_dist);
	tst_abort ((l_phase->nb_dist<=0)," nb_dist <= 0");
	l_phase->radial = l_radial = (RADIAL *)
	tst_alloc (l_phase->nb_dist, sizeof(RADIAL),"radial");
	for (i=0; i<l_phase->nb_dist; i++,l_radial++)
	{   fprintf(list_fich," Distribution #%d\n",i);
	    fscanf (coord_fich," %d",&l_radial->nb_pos);
	    fprintf (list_fich," %d points de definition\n", l_radial->nb_pos);
   /*	    fget_atom (2, -1); */
	    for (j=0,l_atom = &(l_radial->at0); j <2;
					j++,l_atom = &(l_radial->at1))
	    {   fscanf (coord_fich," %s",l_atom->nom);
		fprintf (list_fich," %s %s",l_atom->nom, j==0?"  ":"\n");
		l_atom->nature = -1;
		l_atom->nb = 0;
		check_dif (l_atom->nom);
		}
	    fget_var (&l_radial->distrib, l_radial->nb_pos, 0, VAR_RADIAL, 
                          T_RADIAL, NULL);
	    for (n=0; n<l_radial->nb_pos;n++)
	       fprintf (list_fich," %2d %.3f\n", n, l_radial->diff_pos[n]);
	    for (n=1; n<l_radial->nb_pos;n++)
	      tst_abort ((l_radial->diff_pos[n-1] >= l_radial->diff_pos[n] ),
	       " Distances non-croissantes");
	    }
	}

/* ------------------------------------------------------------------ */

fget_quasi (P_(void))
{   
    l_phase->symgrp = NULL;
    l_phase->n_atom = l_phase->nb_par = l_phase->nb_bloc =
	l_phase->n_orien = 0;
	fscanf (coord_fich,"%d%d", &l_phase->n_prof, &l_phase->nb_hkl);
	fprintf (list_fich,"  %d profil %d raies definies\n\n", l_phase->n_prof,l_phase->nb_hkl);
	tst_abort ( (l_phase->n_prof>1),"trop de profil en quasi");
	tst_abort ( (l_phase->nb_hkl<=0)," Usage  hkl necessaire");
	fget_var (&l_phase->cell,2,0, VAR_STD,T_CELL, (void *)txt_cell);
	fprintf(list_fich,"\n");
	fget_phase_prof();
	fget_var (&l_phase->intens,l_phase->nb_hkl, 0, VAR_HKL,T_HKL, NULL);
	return 0;
	}

/* ------------------------------------------------------------------ */
fget_parasite (P_(void))
{   
	l_phase->symgrp = NULL;
	l_phase->n_atom = l_phase->nb_par = l_phase->nb_bloc =
	l_phase->n_orien = 0;
	fscanf (coord_fich,"%d%d", &l_phase->n_prof, &l_phase->nb_hkl);
	fprintf (list_fich,"  %d profil %d raies definies\n\n", l_phase->n_prof,l_phase->nb_hkl);
	tst_abort ( (l_phase->n_prof>1),"trop de profil en quasi");
	tst_abort ( (l_phase->nb_hkl<=0)," Usage  dist necessaire");
	fget_phase_prof();
	fget_var (&l_phase->intens,2*l_phase->nb_hkl, 2, VAR_STD,
                  T_HKL, (void *)txt_dist);
	return 0;
	}


/* ------------------------------------------------------------------ */

void read_phase (P_(int) phase_num)
#ifdef NO_PROTO
int phase_num;
#endif
{
#define CAS_HKL 7
	char   *txt_nature[CAS_HKL];
	int    i,j;
        
	txt_nature[CAS_HKL-7] = "modulation";
	txt_nature[CAS_HKL-6] = "magnetique";
	txt_nature[CAS_HKL-5] = "quasicubique";
	txt_nature[CAS_HKL-4] = "parasite";
	txt_nature[CAS_HKL-3] = "amorphe";
	txt_nature[CAS_HKL-2] = "hkl_generes";
	txt_nature[CAS_HKL-1] = "hkl_lus";
	l_phase->remark = read_remark();
	fscanf (coord_fich, "%d%d%f", &l_phase->nature, &j,
			&l_phase->temp_orig);
	purge_cr();
	fscanf (coord_fich, " %[^\n]", l_phase->nom);
	i=l_phase->nature+CAS_HKL-2;
	if (i>=CAS_HKL) i=CAS_HKL-1;
	fprintf(list_fich,"\n\n PHASE #%d : %d (%s), %d T transitions, origine du developpement :%.3f\n '%s'\n",
		 phase_num, l_phase->nature,txt_nature[i], j,
                 l_phase->temp_orig, l_phase->nom);
	if (bavard) printf(" PHASE : '%s'\n",l_phase->nom);
        if (l_phase->nature > 0 ) 
        {     l_phase->nb_hkl = l_phase->nature;
              l_phase->nature = 1;
              }
        else l_phase->nb_hkl = 0;
	fget_var (&l_phase->ech, ECH,0, VAR_STD,T_ECHELLE,(void *) txt_ech);
	fget_var (&l_phase->transit,j*TRANSIT,TRANSIT, VAR_STD,
			T_TRANSIT,(void *)txt_transit);
        fprintf(list_fich,"\n");

        switch (l_phase->nature)
	{   case PHASE_AMORPHE  : fget_amorphe ();  break;
	    case PHASE_PARASITE : fget_parasite();  break;
	    case PHASE_QUASI    : fget_quasi   ();  break;
		 default             : fget_crystal ();
	    }
	}

/* ------------------------------------------------------------------ */


