/* XND_TYP.H   Declaration des types */

typedef  short int sint;

typedef struct
{     int     size;
      int     ncle;
      int     ordre;
      int     dim;
      sint    remark;
      float   *value;
      float   *shift;
      int     *codelu;
      int     *param;
      }       VAR;

typedef struct
{     char    nom[SYM_ID];
      char    comment[NAME_LG];
      char    systeme;
      char    holoedre;   /* dimension pour module */
      char    bravais;
      char    centro;
      char    nops;
      char    size;       /*  12 normalement sauf modulation */
      float   coef[1];    /* (xx, xy, xz, tx, yx......zz, tz ) * nops */
      }       SYMGRP;

typedef struct
{     char    nom[8];
      char    cas;        /* 0 = constante, 1 = table interp, 2 TIC, 3 hadju ... */
      int     tot;        /* 0  = expression TIC ou nb de pts */
      float   s;
      float   act;
      float   coef;       /* rx = (9TIC) (ds,nval), neut=(val)  */
	   }       DIFDAT;

typedef struct
{     char    nom[8];
      int     tot;        /* nb de grp de data anomal */
      float   coef[3];       /* lambda, f', f", les 3 premiers sont actifs */
      }       ANODAT;

typedef struct
{     float   so_wp;
      float   sd_wp;
      float   so_p;
      float   sd_p;
      float   sd_wp_cor;
      float   so_wp_b;
      float   sd_wp_b;
      float   so_p_b;
      float   sd_p_b;
      float   s_eff;
      float   d_val;
      int     s_n;
      int     s_n_b;
     }       INDIC;

typedef struct
{     FLOAT   dtheta;
      FLOAT   i_obs;
      FLOAT   weight;
      }       OBS;
      
typedef struct
{     int     h, k, l;
      float   f_obs;
      float   weight;
      }       HKL_OBS;
      
  
typedef struct    
{     int     cumul;
      int     skip;
      int     numvar;
      float   tmin;
      float   mono;
      }       F_INFO;

typedef struct
{     float   temp;
/*    float   pression; */
      int     n_points;
      float   w_mini;
      float   dtheta0;
      float   dthetaf;
      INDIC   indic;
      FLOAT   *points;
      char    fich_name[NAME_LG];
      }       DIAG;

typedef struct
{     char    nom[NAME_LG];
      int     nature;
      int     techn;
      int     dfich;
      int     n_lambda;
      int     n_diag;
      int     n_back;
      int     prof_par;
      int     number;   /* used by orien to adjust function to the experiment */
      sint    remark;
      float   temp_orig;
      float   *back_pos;
      F_INFO  *f_info;
      DIAG    *diag;
      VAR     back;	     /* n_back       */
      VAR     onde;       /* n_lambda x 4 */
      VAR     reglage;    /* 4..6   */
      VAR     instru;     /* 4           */
      VAR     assym;      /* max_assym * 6 */
      }       EXPER;

typedef struct
{     char    nom[8];
      sint    remark;
      DIFDAT  *xdif;
      DIFDAT  *ndif;
      DIFDAT  *uxdif;
      DIFDAT  *undif;
      DIFDAT  *mdif;
      ANODAT  *adif;
      int     nature;     /* 0 , 1 bij , 2 ki, 3 bij+ki .....*/
      int     nb;
      int     n_modul;
      VAR     x;          /* x,y,z,t ,b=b11 (b22 b33 b12 b23 b31) k1 k2 k3 */
      VAR     modul;      /* A_x, A_y, A_z, A_t, P_x, P_y, P_z, P_t, ....  */
      }       ATOM;

typedef struct
{     char    phase;
      short    h[3];
      char    lambda;
      float   dtheta;
      float   w_gauss;
      float   w_lorentz;
      float   assym[MAX_ASSYM];
      float   i_calc;
      float   f_a;
      float   f_b;
      float   f_am;
      float   f_bm;
      float   cor;
      float   orien;
      float   ech;
      float   dist;
      short   mu;
      short   deb;
      short   fin;
      }       BRAGG;

typedef struct
{     int     at;
      float   coef[12];
      }       ENDAT;

typedef struct
{     int     at0;
      ENDAT   *endat;
      }       COORD;

typedef struct
{     int     nb_coord;
      sint    remark;
      float  sigma;
      COORD   *coord;
      VAR     dist;
      }       DIST;

typedef struct
{     int     nb_pos;
      ATOM    at0;
      ATOM    at1;
      float   *diff_pos;
      VAR     distrib;
      }       RADIAL;

typedef struct
{     sint h[3];
      }       HKL;

typedef struct
{      float    matr[6];
       float    vect[3];
       }        SYMOP;

typedef struct
{     VAR    intens;
      HKL   *hkl;
      int    nb_hkl;
      int    hkl_sat[MAX_DIM_MODUL];
      }      SATEL;

typedef struct
{     int     dimension;
      int     nature;
	int     nb_sat;
	float   t_orig; /* for commensurate modulation */
      SATEL *satel;
      VAR     vecteur;
      SYMGRP *symgrp;
      }       TMODUL;

typedef struct
{     char      nom[NAME_LG];
      int       n_atom;   /* independant */
		int       n_orien;
		int       nt_orien; /* n_orien * n_manip */
      int       n_prof;
      int       nb_par;   /* atomiques */
      int       nb_hkl;
      int       nature;
      int       nb_bloc;
      int       nb_atom;   /* en tout */
      int       nb_bond;     /* temps contrainte , nb pas distrib amorphe*/
      int       uncoherent;  /* diffus ( thermique ... */
      int       nb_tds;
      int       nb_dist;   /* distance ou distrib radiale */
      int       nb_angl;
      int       *c_prof;   /*numero des fonctions utilisees */
      int       *c_orien;
      sint      remark;
      sint      remark_orien;
      sint      remark_prof;
      sint      remark_bond;
      float     temp_orig;
      SYMGRP    *symgrp;
      VAR       ech;      /* table de 2 */
      VAR       transit;  /* table de 3 */
      VAR       cell;     /* table de 6 */
      VAR       prof;     /* table de 4*n_prof */
      VAR       assym;    /* table max_assym*n_assym*PASSYM */
      VAR       orien;    /* table de n_orien   */
      VAR       dif_ech;  /* table de 1 */
      ATOM      *atom;
      HKL       *hkl;
      HKL       *hkl_tds;
      VAR       intens;
      VAR       tds;
      float     *bond;     /* temps contrainte */
      DIST      *dist;
      DIST      *angl;
      RADIAL    *radial;
      VAR        bloc;
      int       *bl_atom;
      ATOM     **bl_ortho;
      ATOM     **bl_relat;
      TMODUL    *magnet;
      TMODUL    *modul;
      }         PHASE;


