/*  XND_VAR.H   declaration des variables globales */

 EXTERN char  titre[NAME_LG];
 EXTERN char  *str_time;
				     /*  file system */
 EXTERN FILE  *list_fich;
 EXTERN FILE  *new_fich;
 EXTERN FILE  *hkl_fich;
 EXTERN FILE  *plg_fich;
 EXTERN FILE  *data_fich;
 EXTERN FILE  *dydp_fich;
 EXTERN FILE  *bragg_fich;
 EXTERN FILE  *remark_fich;
 EXTERN sint  end0_remark;
 EXTERN sint  end1_remark;
 EXTERN char  dydp_name[NAME_LG];
 EXTERN char  data_name[NAME_LG];
 EXTERN char  remark_name[NAME_LG];
 EXTERN char  new_name[NAME_LG];
 EXTERN char  plg_name[NAME_LG];
 EXTERN char  hkl_name[NAME_LG];
 EXTERN char  list_name[NAME_LG];


 EXTERN int   cycle;                 /* general parameters */
 EXTERN int   max_cycle;
 EXTERN int   c_marquardt;
 EXTERN int   mod_lsq;
 EXTERN int   back_mode;
 EXTERN int   tot_prof_par;
 EXTERN int   phase_prof_par;
 EXTERN int   voigt_mode;
 EXTERN int   assym_mode;
 EXTERN int   unc_mode;
 EXTERN int   valid_ref;
 EXTERN int   test_mode;
 EXTERN float eps_stop;
 EXTERN float eps_prof;
 EXTERN float stabil;
 EXTERN float marquardt;
 EXTERN float val_sigma;
 EXTERN float xt_eff;
 EXTERN float opt_deplace;
 EXTERN float u_exp;
 EXTERN float u_sin;
			/* constantes modifiables en mode test */
#ifdef EXTERN_NOT_SPACE
 extern float bragg_repart;
#else
	float bragg_repart = 0.5;
#endif
 
                          /* io parameters */
 EXTERN int   prt_new;
 EXTERN int   prt_hkl;
 EXTERN int   prt_plg;
 EXTERN int   prt_cor;
 EXTERN int   disk_dydp;
 EXTERN int   disk_data;
 EXTERN char  bavard;
 EXTERN char  fini;
 EXTERN int   minli;

				     /* effective size */
 EXTERN int   n_exper;
 EXTERN int   n_phase;               /* declarees */
 EXTERN int   tot_phase;             /* incluant modulees */
 EXTERN int   n_var;
 EXTERN int   n_par;
 EXTERN int   n_pen;
 EXTERN int   n_mat;
 EXTERN int   n_sym;
 EXTERN int   n_dif;
 EXTERN int   nt_diag;
				    /* basic pointers */
 EXTERN EXPER  *exper;
 EXTERN PHASE  *phase;
 EXTERN FLOAT  *matrice;
 EXTERN FLOAT  *y_vect;
 EXTERN FLOAT  *dy_dp;
 EXTERN float  *shift_e;
 EXTERN float  *prof_mat;
 EXTERN int    *prof_pos;
 				    /* current pointers */
 EXTERN SYMGRP *l_symgrp;
 EXTERN EXPER  *l_exper;
 EXTERN VAR    *l_onde;
 EXTERN VAR    *l_instru;
 EXTERN VAR    *l_assym;
 EXTERN VAR    *l_reglage;
 EXTERN PHASE  *l_phase;
 EXTERN DIAG   *l_diag;
 EXTERN FLOAT  *l_points;
 EXTERN ATOM   *l_atom;
 EXTERN VAR    *l_bloc;
 EXTERN INDIC  *l_indic;
 EXTERN RADIAL *l_radial;
 EXTERN TMODUL *l_magnet;
 EXTERN SATEL  *l_satel;
				   /* actual variable */
 EXTERN VAR    *variable;
 EXTERN int    ordre;
 EXTERN int    dim;
 EXTERN int    io;
 EXTERN int    id;
 
				   /* actual parameters */
 EXTERN float  *temp;
 EXTERN float  temp_phase;
 EXTERN float  q, tan_t;
 EXTERN char   centro,systeme,bravais;
 EXTERN float  h_eff, k_eff, l_eff;
 EXTERN float  g_aa,g_ab,g_ac,g_bb,g_bc,g_cc;  /* reciprocal metric */
 EXTERN float  d_aa,d_bb,d_cc,d_ab,d_ac,d_bc;  /* direct */
 EXTERN float  na_b,nb_b,nc_b;                 /* unit vect b for orien */
 EXTERN float  d_metrique[6];
 EXTERN unsigned n_pts;
 EXTERN unsigned dif_nature;
 EXTERN int     fhkl_mult;      /* multiply factor for hkl according to sym */
 EXTERN int     magnet;
 EXTERN int     incom;
 EXTERN int     sat;
 EXTERN int     max_assym;
				/* value for overall Bragg factors */
 EXTERN int    obrg_n[4];       /* R_B, R_F, R_wB, R_wF */
 EXTERN float  obrg_s[4];
 EXTERN float  obrg_d[4];

 EXTERN BRAGG  act;                 /* used with macro defined : H,K...*/
#define    H        act.h[0]
#define    K        act.h[1]
#define    L        act.h[2]
#define    DTH      act.dtheta
#define    I_C      act.i_calc
#define    F_A      act.f_a
#define    F_B      act.f_b
#define    W_G      act.w_gauss
#define    W_L      act.w_lorentz

				    /* general labels */
#ifdef EXTERN_NOT_SPACE
 extern  char   *txt_instru[INSTRU];
 extern  char   *txt_assym[ASSYM];
 extern  char   *txt_onde  [LAMBDA];
 extern  char   *txt_reglage[REGLAGE];
 extern  char   *txt_orien[ORIEN];
 extern  char   *txt_ech[ECH];
 extern  char   *txt_transit[TRANSIT];
 extern  char   *txt_cell[CELL];
 extern  char   *txt_prof[PROF];
 extern  char   *txt_passym[PASSYM];
 extern  char   *txt_atom[COORD_DIM];
 extern  char   *txt_modul[AMODUL];
 extern  char   *txt_bloc[BCOOR];
 extern  char   *txt_dist[2];
 extern  char   *txt_angl[1];
 extern  char   *txt_vecteur[VECTEUR];
 extern  char   *txt_dif[DIF];
 extern  char   *txt_difech[1];
#else
 char   *txt_instru[INSTRU]= {"Wl0","Wg0","Wl_T2","Wg_T2"};
 char   *txt_assym[ASSYM]= {"A_T2","A_T","AS"};
 char   *txt_onde[LAMBDA]   = {"Lamda","Int.","WlT-t","WgT-t"};
 char   *txt_reglage[REGLAGE]= {"Zero","Polar","Tmono","S_Ecl","Tassym","Absorb"};
 char   *txt_orien[ORIEN]  = {"coef","teta","phi"};
 char   *txt_ech[ECH]     = {"Scale","Bo"};
 char   *txt_transit[TRANSIT]     = {"T_o","D_T","Exp"};
 char   *txt_cell[CELL]   = {"Centr.","A","B","C","Alpha","Beta","Gamma"};
 char   *txt_prof[PROF]   =
		   {"Wl_C","Wg_C","WlT","WgT", "TETA","PHI"};
 char   *txt_passym[PASSYM]   =
		   { "A0","AT"};
 char   *txt_atom[COORD_DIM] =
		  { "X", "Y", "Z", "T", "B",
		    "B11", "B22", "B33", "B12", "B13", "B23",
		    "Kx", "Ky", "Kz"};
 char   *txt_modul[AMODUL] =
		  { "S_x", "C_x", "S_y", "C_y", 
		    "S_z", "C_z", "S_t", "C_t" };
 char   *txt_bloc[BCOOR] = 
                  { "X_Bl","Y_Bl","Z_Bl","TET","PHI","PSI"};
 char   *txt_dist[2]      =    { "Dist","Int"};
 char   *txt_angl[1]      =  { "Angl"};
 char   *txt_vecteur[VECTEUR]   = {"d_a*","d_b*","d_c*"};
 char   *txt_dif[DIF]     = {"i", "wl"};
 char   *txt_difech[1]     = {"dif_sc"};
#endif
